DROP TRIGGER "TR_LD_RegBK_AD";
DROP TRIGGER "TR_LD_RegBK_AU";
DROP TRIGGER "TR_LD_RegBK_BI";
DROP TRIGGER "TR_LD_RegBK_BU";
DROP TRIGGER "TR_LD_RegBK_BU_500";

CREATE OR REPLACE TRIGGER "TR_LD_REGBK_AD" 
  AFTER DELETE
  ON LayerData_RegBK
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AD_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    
end;
/
ALTER TRIGGER "TR_LD_REGBK_AD" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_REGBK_AI" 
  AFTER INSERT
  ON LayerData_RegBK
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  delete from DelRecIndexes where (TableID = 174) and (RecordID = :new.ID);
  
end;
/
ALTER TRIGGER "TR_LD_REGBK_AI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_REGBK_AU" 
  AFTER UPDATE
  ON LayerData_RegBK
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- AU_500
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.ID<>:old.ID) then
    insert into DelRecIndexes(TableID, RecordId, DeleteDate) values (174, :old.ID, SYSDATE);
    delete from DelRecIndexes where (TableID=174) and (RecordId=:new.ID);
  end if;
  
end;
/
ALTER TRIGGER "TR_LD_REGBK_AU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_REGBK_BI" 
  BEFORE INSERT
  ON LayerData_RegBK
  FOR EACH ROW
declare
  fac NUMBER(10);
begin

-- - - - - - - - - - - - -
-- BI_(0)
-- Create 05.09.2005
-- Last Update 22.05.2009
-- - - - - - - - - - - - -

    if (:new.id is null) then select g_Shared.nextval into :new.Id from DUAL; end if;
    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    if ((:new.FacialAccCls is null) and (:new.TaskRef is not null)) then
      BEGIN
        select FacialAccCls into fac from LayerTasks where ID = :new.TaskRef;
        :new.FacialAccCls := fac;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN NULL;
      END;
    end if;
    if (:new.TaskRef is not null) then
      BEGIN
        select LayerVersion, DocStateRef, AcceptDate, RejectDate, OwnerUser, ExecuterUser
          into :new.LayerVersion, :new.DocStateRef, :new.AcceptDate, :new.RejectDate,
          :new.OwnerUser, :new.ExecuterUser
        from LayerTasks where ID = :new.TaskRef;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          :new.LayerVersion := NULL;
          :new.DocStateRef := NULL;
          :new.AcceptDate := NULL;
          :new.RejectDate := NULL;
          :new.OwnerUser := NULL;
          :new.ExecuterUser := NULL;
      END;  
    end if;
    
-- - - - - - - - - - - - -
-- BI_500
-- Create 05.09.2005
-- - - - - - - - - - - - -
  :NEW.CreateDate := SYSDATE;
  :NEW.UpdateDate := :NEW.CreateDate;
  :NEW.CreaterUser := USER;
  :NEW.UpdaterUser := USER;
end;
/
ALTER TRIGGER "TR_LD_REGBK_BI" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_REGBK_BU" 
  BEFORE UPDATE
  ON LayerData_RegBK
  FOR EACH ROW
begin

-- - - - - - - - - - - - -
-- BU_(0)
-- Create 05.09.2005
-- - - - - - - - - - - - -

    if (:new.LayerVersion is null) then :new.LayerVersion := 0; end if;
    if (:new.ExecuterUser is null) then :new.ExecuterUser := :new.OwnerUser; end if;
    
-- - - - - - - - - - - - -
-- BU_700
-- Create 05.09.2005
-- - - - - - - - - - - - -

  if (:new.RVersion is null) then
    :new.RVersion := 1;
  elsif ((:new.RVersion = -1) and (:old.RVersion <> -1)) then
    :new.RVersion := :old.RVersion;
  else
    :new.RVersion := :old.RVersion+1;
  end if;

end;
/
ALTER TRIGGER "TR_LD_REGBK_BU" ENABLE;

  CREATE OR REPLACE TRIGGER "TR_LD_REGBK_BU_500" 
  BEFORE UPDATE
  ON LayerData_RegBK
  FOR EACH ROW
begin
-- - - - - - - - - - - - -
-- BU_500
-- - - - - - - - - - - - -
    :new.UpdateDate := SYSDATE;
    :new.UpdaterUser := User;
end;
/

ALTER TRIGGER "TR_LD_REGBK_BU_500" ENABLE;

COMMIT WORK;

